
#include <sys/types.h>
#include <sys/stat.h>

#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "functions.h"

int fd;
int log_fd;

int main(int argc, char *argv[])
{
 char call_from[15];
 char call_to[8];
 char line[80];


 /* Install signal handlers */
 
 signal(SIGTERM,telos);		/* Handler for end of process              */

 signal(SIGCHLD,SIG_IGN);	/* Ingore SIGCHLD, preventing cid_gui      */
 				/* become a zombie process                 */



 /* Open netMod device for initializing */

 fd=open(netMod,O_WRONLY|O_NONBLOCK);

 if (fd<0)
 {
  perror("cid_base:Device netMod opening (r/w) failed");
  exit(1);
 }



 /* Open log file */

 log_fd=open_log();

 if (log_fd<0)
 {
  perror("cid_base:Error opening log file");
  exit(1);
 }



 /* Lock netMod */

 if (lock_netMod())
 {
  perror("cid_base:Error creating lock file");
  exit(1);
 }



 /* Init netMod */

 if (init_netMod(fd))
 {
  perror("cid_base:Error initializing netMod");
  unlink(lockfile);
  exit(1);
 }


 /* Close netMod device, and open again with SYNC option */

 close(fd);
 
 fd=open(netMod,O_RDWR|O_SYNC);

 if (fd<0)
 {
  perror("cid_base:Device netMod opening (r/w) failed");
  unlink(lockfile);
  exit(1);
 }


 
 /* Reset netMod */

 if (reset_netMod(fd,line))
 {
  write(1,"cid_base:Error reseting netMod\n",22);
  unlink(lockfile);
  exit(1);
 }



 /* Adjust netMod to accept voice calls */

 if (adjust_netMod(fd,line))
 {
  write(1,"cid_base:Error adjusting netMod\n",22);
  unlink(lockfile);
  exit(1);
 }



 /* Send signal to father process (cid menu) - Everything ok */

 if (kill(getppid(),SIGUSR1))
 {
  perror("cid_base:Error sending signal");
  unlink(lockfile);
  exit(1);
 }



 /* Wait for incoming calls. When one occurs, open cid_gui */

 while (1)
 {
  
  if ( readline(line,fd)>4 )
  {
   if ( strncmp(line,RING,4)==0 )
   
   /* INCOMING CALL DETECTED */

   {
    if (proccess_line(line,call_from,call_to)>0)
    {

     new_log_entry(log_fd,call_from,call_to);

     if (fork()==0)
     {
      signal(SIGTERM,SIG_DFL);
      signal(SIGCHLD,SIG_DFL);

      execlp("cid_gui","cid_gui",call_from,call_to,(char *)0);
      perror("Cannot create proccess");
      exit(0);
     }
    }
   }
  }
  
 }

}
