#include "menu.h"

#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>



cid_menu::cid_menu(QWidget *parent , char * name )
			: QWidget(parent,name)
{
 cid_running=0;
 cid_pid=0;
 
 back = new QWidget();
 back->resize(100,200);

 start = new QPushButton("Start cid",back);
 start->resize(60,30);
 start->move(20,10);

 stop = new QPushButton("Stop cid",back);
 stop->resize(60,30);
 stop->move(20,60);

 quit = new QPushButton("Quit",back);
 quit->resize(60,30);
 quit->move(20,160);

 status = new QLabel(back);
 status->resize(80,30);
 status->move(10,110);
 status->setText("Waiting");

 QObject::connect(quit,SIGNAL(clicked()),qApp,SLOT(quit()));
 QObject::connect(start,SIGNAL(clicked()),SLOT(start_cid()));
 QObject::connect(stop,SIGNAL(clicked()),SLOT(stop_cid()));

 qApp->setMainWidget(back);

}



void cid_menu::start_cid()
{

 if (cid_running)
 {
  QMessageBox::information(this,"Error starting cid",
 		"CID is already running!");
 }
 else
 {

  if ( !(cid_pid=fork()) )
  {

   signal(SIGCHLD,SIG_DFL);
   signal(SIGUSR1,SIG_DFL);

   if ( execlp("cid_base","cid_base",(char *)0) < 0)
   {
    perror("Error starting cid_base");
    exit(1);
   }

  }
  
 }
  
}



void cid_menu::stop_cid()
{
 if (cid_running)
 {
 
  if (kill(cid_pid,SIGTERM)<0)
  {
   perror("Cannot kill cid process");
  }

 }
 else
 {
  QMessageBox::information(this,"Error stopping cid","CID is not running!");
 }
}



void cid_menu::show()
{
 back->show();
}



cid_menu:: ~cid_menu()
{
 if (cid_running)
 {
  stop_cid();
 }

}



void cid_menu::change_status(char * s)
{
if ( s )
 {
  status->setText(s);
 }
}



void cid_menu::handle_chld(int i)
{
 int status=-1;
 int child=0;
 
 child=waitpid(0,&status,WNOHANG|WUNTRACED);

 /* printf("pira sig-child apo %d (%d)\n",child,cid_pid);*/

 if (child<0)
 {
  perror("cid: Error waiting signal");
 }
 else
 {
  if (!WIFSTOPPED(status)) {
  if (status==0)
  {
   change_status("CID Stopped");
  }
  else
  {
   change_status("CID ERROR");
  }

  cid_running=0;}
 }

 signal(SIGCHLD,signal_handle_chld);
}



void cid_menu::handle_cont(int i)
{
 /*printf("pira sig-usr1\n");*/

 change_status("CID Running");
 cid_running=1;

 signal(SIGUSR1,signal_handle_cont);
}
	
